let audioContextInstance;
let gainNode;
let mediaSource;
let audioStream;

const start = (streamId) => {
  navigator.mediaDevices.getUserMedia({
    audio: {
      mandatory: {
        chromeMediaSource: "tab",
        chromeMediaSourceId: streamId
      }
    },
    video: false
  })
    .then((stream) => {
      if (!stream) {
        return;
      }

      audioStream = stream;
      audioContextInstance = new AudioContext();
      mediaSource = audioContextInstance.createMediaStreamSource(audioStream);
      gainNode = audioContextInstance.createGain();

      mediaSource.connect(gainNode);
      gainNode.connect(audioContextInstance.destination);
      gainNode.gain.value = 4;
    });
}

chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.target !== "offscreen") return;

  switch (message.action) {
    case "start":
      start(message.data);
      break;
    case "volume":
      gainNode.gain.value = 2 ** parseFloat(message.data);
      break;
  }
});
